Class UmlBasePackage

Manage the packages

Declaration :

- C++ : class UmlBasePackage : public UmlItem
- Java : abstract class UmlBasePackage extends UmlItem

Directly inherited by : UmlPackage

Artifact : UmlBasePackage

Operation create

returns a new package named 'name' created under 'parent'
In case it cannot be created (the name is already used or
invalid, 'parent' cannot contain it etc ...) return 0 in C++
and produce a RuntimeException in Java

Declaration :

- Uml : static, + create(inout parent : UmlPackage, in name : str) : UmlPackage, exceptions : RuntimeException
- C++ : public: static UmlPackage * create(UmlPackage * parent, const char * name)
- Java : public static UmlPackage create(UmlPackage parent, String name) throws RuntimeException

Operation kind

returns the kind of the item

Declaration :

- Uml : + kind() : anItemKind
- C++ : public: virtual anItemKind kind()
- Java : public anItemKind kind()

Operation associatedDiagram

returns the optional associated diagram

Declaration :

- Uml : + associatedDiagram() : UmlDiagram
- C++ : public: UmlDiagram * associatedDiagram()
- Java : public UmlDiagram associatedDiagram()

Operation set_AssociatedDiagram

sets the associated diagram, arg may be null to unset it
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : + set_AssociatedDiagram(inout d : UmlDiagram) : bool, exceptions : RuntimeException
- C++ : public: bool set_AssociatedDiagram(UmlDiagram * d)
- Java : public void set_AssociatedDiagram(UmlDiagram d) throws RuntimeException

Operation importProject

Import a project in the current package
fn is the pathname of the .prj file of the project to import
or an empty string (the project will be set through a dialog)
Return the new UmlPackage containing the imported project, or
0/null on error

Declaration :

- Uml : + importProject(in fn : string) : UmlPackage
- C++ : public: UmlPackage * importProject(const QCString & fn)
- Java : public UmlPackage importProject(String fn)

Operation cppSrcDir

returns the path where the C++ source files are generated by the
c++ generator.

Declaration :

- Uml : + cppSrcDir() : string
- C++ : public: const QCString & cppSrcDir()
- Java : public String cppSrcDir()

Operation set_CppSrcDir

to set the path where the C++ source files are generated by the
C++ generator, may be relative even the 'root' path is not
(already) an absolute path
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : + set_CppSrcDir(in s : string) : bool, exceptions : RuntimeException
- C++ : public: bool set_CppSrcDir(const QCString & s)
- Java : public void set_CppSrcDir(String s) throws RuntimeException

Operation cppHDir

returns the path where the C++ header files are generated by the
C++ generator.

Declaration :

- Uml : + cppHDir() : string
- C++ : public: const QCString & cppHDir()
- Java : public String cppHDir()

Operation set_CppHDir

to set the path where the C++ header files are generated by the
C++ generator, may be relative even the 'root' path is not
(already) an absolute path
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : + set_CppHDir(in s : string) : bool, exceptions : RuntimeException
- C++ : public: bool set_CppHDir(const QCString & s)
- Java : public void set_CppHDir(String s) throws RuntimeException

Operation cppNamespace

returns the namespace name associed to the package

Declaration :

- Uml : + cppNamespace() : string
- C++ : public: QCString cppNamespace()
- Java : public String cppNamespace()

Operation set_CppNamespace

to set the namespace name associed to the package.
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : + set_CppNamespace(in s : string) : bool, exceptions : RuntimeException
- C++ : public: bool set_CppNamespace(const QCString & s)
- Java : public void set_CppNamespace(String s) throws RuntimeException

Operation findCppNamespace

returns a sub package of the current one having the c++ namespace 'n'
(including the current one), else 0/null

Declaration :

- Uml : + findCppNamespace(in n : string) : UmlPackage
- C++ : public: UmlPackage * findCppNamespace(const QCString & n) const
- Java : public UmlPackage findCppNamespace(String n)

Operation javaDir

returns the path where the JAVA files are generated by the
JAVA generator.

Declaration :

- Uml : + javaDir() : string
- C++ : public: const QCString & javaDir()
- Java : public String javaDir()

Operation set_JavaDir

to set the path where the JAVA files are generated by the
JAVA generator, may be relative even the 'root' path is not
(already) an absolute path
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : + set_JavaDir(in s : string) : bool, exceptions : RuntimeException
- C++ : public: bool set_JavaDir(const QCString & s)
- Java : public void set_JavaDir(String s) throws RuntimeException

Operation javaPackage

returns the java package name associed to the package

Declaration :

- Uml : + javaPackage() : string
- C++ : public: QCString javaPackage()
- Java : public String javaPackage()

Operation set_JavaPackage

to set the java package name associed to the package.
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : + set_JavaPackage(in s : string) : bool, exceptions : RuntimeException
- C++ : public: bool set_JavaPackage(const QCString & s)
- Java : public void set_JavaPackage(String s) throws RuntimeException

Operation findJavaPackage

returns a sub package of the current one having the Java package 'n'
(including the current one), else 0/null

Declaration :

- Uml : + findJavaPackage(in n : string) : UmlPackage
- C++ : public: UmlPackage * findJavaPackage(const QCString & n) const
- Java : public UmlPackage findJavaPackage(String n)

Operation phpDir

returns the path where the PHP files are generated by the
PHP generator.

Declaration :

- Uml : + phpDir() : string
- C++ : public: const QCString & phpDir()
- Java : public String phpDir()

Operation set_PhpDir

to set the path where the PHP files are generated by the
PHP generator, may be relative even the 'root' path is not
(already) an absolute path
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : + set_PhpDir(in s : string) : bool, exceptions : RuntimeException
- C++ : public: bool set_PhpDir(const QCString & s)
- Java : public void set_PhpDir(String s) throws RuntimeException

Operation pythonDir

returns the path where the PYTHON files are generated by the
PYTHON generator.

Declaration :

- Uml : + pythonDir() : string
- C++ : public: const QCString & pythonDir()
- Java : public String pythonDir()

Operation set_PythonDir

to set the path where the PYTHON files are generated by the
PYTHON generator, may be relative even the 'root' path is not
(already) an absolute path
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : + set_PythonDir(in s : string) : bool, exceptions : RuntimeException
- C++ : public: bool set_PythonDir(const QCString & s)
- Java : public void set_PythonDir(String s) throws RuntimeException

Operation pythonPackage

returns the python package name associed to the package

Declaration :

- Uml : + pythonPackage() : string
- C++ : public: QCString pythonPackage()
- Java : public String pythonPackage()

Operation set_PythonPackage

to set the python package name associed to the package.
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : + set_PythonPackage(in s : string) : bool, exceptions : RuntimeException
- C++ : public: bool set_PythonPackage(const QCString & s)
- Java : public void set_PythonPackage(String s) throws RuntimeException

Operation findPythonPackage

returns a sub package of the current one having the Python package 'n'
(including the current one), else 0/null

Declaration :

- Uml : + findPythonPackage(in n : string) : UmlPackage
- C++ : public: UmlPackage * findPythonPackage(const QCString & n) const
- Java : public UmlPackage findPythonPackage(String n)

Operation idlDir

returns the path where the IDL files are generated by the
IDL generator.

Declaration :

- Uml : + idlDir() : string
- C++ : public: const QCString & idlDir()
- Java : public String idlDir()

Operation set_IdlDir

to set the path where the IDL files are generated by the
IDL generator, may be relative even the 'root' path is not
(already) an absolute path
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : + set_IdlDir(in s : string) : bool, exceptions : RuntimeException
- C++ : public: bool set_IdlDir(const QCString & s)
- Java : public void set_IdlDir(String s) throws RuntimeException

Operation idlModule

returns the module name associed to the package

Declaration :

- Uml : + idlModule() : string
- C++ : public: QCString idlModule()
- Java : public String idlModule()

Operation set_IdlModule

to set the module name associed to the package.
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : + set_IdlModule(in s : string) : bool, exceptions : RuntimeException
- C++ : public: bool set_IdlModule(const QCString & s)
- Java : public void set_IdlModule(String s) throws RuntimeException

Operation findIdlModule

returns a sub package of the current one having the IDL module 'n'
(including the current one), else 0/null

Declaration :

- Uml : + findIdlModule(in n : string) : UmlPackage
- C++ : public: UmlPackage * findIdlModule(const QCString & n) const
- Java : public UmlPackage findIdlModule(String n)

Operation getProject

Returns the project

Declaration :

- Uml : static, + getProject() : UmlPackage
- C++ : public: static UmlPackage * getProject()
- Java : public static UmlPackage getProject()

Operation isProjectModified

return TRUE in case something is modified (i.e. the project must be saved)

Declaration :

- Uml : static, + isProjectModified() : bool
- C++ : public: static bool isProjectModified()
- Java : public static boolean isProjectModified()

Operation saveProject

save the project if needed

Declaration :

- Uml : static, + saveProject() : void
- C++ : public: static void saveProject()
- Java : public static void saveProject()

Operation loadProject

Does nothing in case an edition is on going under BOUML. Else :
close the current project (in case it is not saved the last modifications are lost),
load the specified one, and all the communications with the plug-outs including the
current one are closed.

Declaration :

- Uml : static, + loadProject(inout p : string) : void
- C++ : public: static void loadProject(QCString p)
- Java : public static void loadProject(String p)

Operation updateProfiles

Force consistency concerning the profiles and their stereotypes

Declaration :

- Uml : static, + updateProfiles() : void
- C++ : public: static void updateProfiles()
- Java : public static void updateProfiles()

Operation unload

to unload the object to free memory, it will be reloaded automatically
if needed. Recursively done for the sub items if 'rec' is TRUE.
if 'del' is true the sub items are deleted in C++, and removed from the
internal dictionnary in C++ and Java (to allow it to be garbaged),
you will have to call Children() to re-access to them

Declaration :

- Uml : + unload(in rec : bool, in del : bool) : void
- C++ : public: virtual void unload(bool rec = FALSE, bool del = FALSE)
- Java : public void unload(boolean rec, boolean del)

Relation _assoc_diagram (<unidirectional association>)

Declaration :

- Uml : - _assoc_diagram : UmlDiagram
- C++ : private: UmlDiagram * _assoc_diagram
- Java : private UmlDiagram _assoc_diagram

Attribute _cpp_src_dir

Declaration :

- Uml : - _cpp_src_dir : string
- C++ : private: QCString _cpp_src_dir
- Java : private String _cpp_src_dir

Attribute _cpp_h_dir

Declaration :

- Uml : - _cpp_h_dir : string
- C++ : private: QCString _cpp_h_dir
- Java : private String _cpp_h_dir

Attribute _cpp_namespace

Declaration :

- Uml : - _cpp_namespace : string
- C++ : private: QCString _cpp_namespace
- Java : private String _cpp_namespace

Attribute _java_dir

Declaration :

- Uml : - _java_dir : string
- C++ : private: QCString _java_dir
- Java : private String _java_dir

Attribute _java_package

Declaration :

- Uml : - _java_package : string
- C++ : private: QCString _java_package
- Java : private String _java_package

Attribute _php_dir

Declaration :

- Uml : - _php_dir : string
- C++ : private: QCString _php_dir
- Java : private String _php_dir

Attribute _python_dir

Declaration :

- Uml : - _python_dir : string
- C++ : private: QCString _python_dir
- Java : private String _python_dir

Attribute _python_package

Declaration :

- Uml : - _python_package : string
- C++ : private: QCString _python_package
- Java : private String _python_package

Attribute _idl_dir

Declaration :

- Uml : - _idl_dir : string
- C++ : private: QCString _idl_dir
- Java : private String _idl_dir

Attribute _idl_module

Declaration :

- Uml : - _idl_module : string
- C++ : private: QCString _idl_module
- Java : private String _idl_module

Operation read_uml_

internal, do NOT use it

Declaration :

- Uml : # read_uml_() : void
- C++ : protected: virtual void read_uml_()
- Java : protected void read_uml_()

Operation read_cpp_

internal, do NOT use it

Declaration :

- Uml : # read_cpp_() : void
- C++ : protected: virtual void read_cpp_()
- Java : protected void read_cpp_()

Operation read_java_

internal, do NOT use it

Declaration :

- Uml : # read_java_() : void
- C++ : protected: virtual void read_java_()
- Java : protected void read_java_()

Operation read_php_

internal, do NOT use it

Declaration :

- Uml : # read_php_() : void
- C++ : protected: virtual void read_php_()
- Java : protected void read_php_()

Operation read_python_

internal, do NOT use it

Declaration :

- Uml : # read_python_() : void
- C++ : protected: virtual void read_python_()
- Java : protected void read_python_()

Operation read_idl_

internal, do NOT use it

Declaration :

- Uml : # read_idl_() : void
- C++ : protected: virtual void read_idl_()
- Java : protected void read_idl_()

Operation UmlBasePackage

the constructor, do not call it yourself !!!!!!!!!!

Declaration :

- Uml : # UmlBasePackage(in id : item_id, in n : string) :
- C++ : protected: UmlBasePackage(void * id, const QCString & n)
- Java : protected UmlBasePackage(long id, String n)

All public operations : apply , applyStereotype , associatedDiagram , children , childrenVisible , cppHDir , cppNamespace , cppSrcDir , create , defined_ , deleteIt , description , findCppNamespace , findIdlModule , findJavaPackage , findPythonPackage , getIdentifier , getProject , identifier_ , idlDir , idlModule , importProject , isMarked , isProjectModified , isToolRunning , isWritable , javaDir , javaPackage , kind , kind , loadProject , markedItems , moveAfter , name , parent , phpDir , properties , propertyValue , pythonDir , pythonPackage , referencedBy , saveProject , set_AssociatedDiagram , set_childrenVisible , set_CppHDir , set_CppNamespace , set_CppSrcDir , set_Description , set_IdlDir , set_IdlModule , set_isMarked , set_JavaDir , set_JavaPackage , set_Name , set_PhpDir , set_PropertyValue , set_PythonDir , set_PythonPackage , set_Stereotype , stereotype , supportFile , unload , unload , updateProfiles